/*
===============================================================================
 Name        : main.c

 Author      : S.NISHIOKA
 Version     :

===============================================================================
*/

#ifdef __USE_CMSIS
#include "LPC11xx.h"
#endif

//#include "NS5000_macro.h"



// TODO: insert other definitions and declarations here

int sound_timer=0;		//Beep時間　=0.5ms * sound_timer
int timer_clock=0;		//初期設定からの　経過時間　標準時

/*
-------------------------------------------------------
   int main() :
     Main routine.
-------------------------------------------------------
*/
int main(void) {
	int i;
//	int		var;
    int		var0;
    int		var1;
    int		var2;
    int		var3;

    // Configure PORT
    LPC_GPIO0->DIR  |= (1<<7);           // Configure PIO0_7 as LED output
    LPC_GPIO0->DIR  |= (1<<8);           // Configure PIO0_8 as Beep


//	各タイマーモジュールにクロックを供給する
//     LPC_SYSCON->SYSAHBCLKCTRL |= (1UL << 7);	// Enable clock for CT16B0 module
//     LPC_SYSCON->SYSAHBCLKCTRL |= (1UL << 8);	// Enable clock for CT16B1 module
//     LPC_SYSCON->SYSAHBCLKCTRL |= (1UL << 9);	// Enable clock for CT32B0 module
//     LPC_SYSCON->SYSAHBCLKCTRL |= (1UL << 10);// Enable clock for CT32B1 module
	LPC_SYSCON->SYSAHBCLKCTRL |= 0b0000011110000000;


/* Set up NVIC 各タイマ割り込みを有効化しておく　 */
	NVIC_EnableIRQ(TIMER_16_0_IRQn);
	NVIC_EnableIRQ(TIMER_16_1_IRQn);
	NVIC_EnableIRQ(TIMER_32_0_IRQn);
	NVIC_EnableIRQ(TIMER_32_1_IRQn);


//RA 赤経
    LPC_TMR16B0->PR = (3*64)-1;			//48MHz/3=16MHz,16MHz/64=250KHz に分周する
    LPC_TMR16B0->MR3 = 6495-1;			//26ms　=4us*6495 を設定しておく、暫定である
    LPC_TMR16B0->MCR &= ~(7UL << 9);	// Reset timer with MATCH3 events.
    LPC_TMR16B0->MCR |=  (3UL << 9);	//割り込み有効、タイマリセットする
    NVIC_SetPriority(TIMER_16_0_IRQn,1);//割り込みレベル
    LPC_TMR16B0->TCR = 1;				//タイマスタート
    var0= NVIC_GetPriority(TIMER_16_0_IRQn);


//DEC　赤緯
    LPC_TMR16B1->PR = (3*64)-1;			//48MHz/3=16MHz,16MHz/64=250KHz に分周する
    LPC_TMR16B1->MR3 = 6495-1;			//26ms　=4us*6495 を設定しておく、暫定である
    LPC_TMR16B1->MCR &= ~(7UL << 9);	// Reset timer with MATCH3 events.
    LPC_TMR16B1->MCR |=  (3UL << 9);	//割り込み有効、タイマリセットする
    NVIC_SetPriority(TIMER_16_1_IRQn,1);//割り込みレベル
    LPC_TMR16B1->TCR = 1;				//タイマスタート
    var1= NVIC_GetPriority(TIMER_16_1_IRQn);


//恒星時時計、他　							//恒星時の１秒を作る
    LPC_TMR32B0->PR = (3*64)-1;			//48MHz/3=16MHz,16MHz/64=250KHz に分周する
    LPC_TMR32B0->MR3 = 2494-1;			//9.976msec　=4us*2494
    LPC_TMR32B0->MCR &= ~(7UL << 9);	// Reset timer with MATCH3 events.
    LPC_TMR32B0->MCR |=  (3UL << 9);	//割り込み有効、タイマリセットする
    NVIC_SetPriority(TIMER_32_0_IRQn,3);//割り込みレベル
    LPC_TMR32B0->TCR = 1;				//タイマスタート
    var2= NVIC_GetPriority(TIMER_32_0_IRQn);


//標準時、Beep　 							//標準時の１秒, サウンド機能を提供する
    LPC_TMR32B1->PR = (3*64)-1;			//48MHz/3=16MHz,16MHz/64=250KHz に分周する
    LPC_TMR32B1->MR3 = 125-1;			//500usec　=4us*125
    LPC_TMR32B1->MCR &= ~(7UL << 9);	// Reset timer with MATCH3 events.
    LPC_TMR32B1->MCR |=  (3UL << 9);	//割り込み有効、タイマリセットする
    NVIC_SetPriority(TIMER_32_1_IRQn,2);//割り込みレベル
    LPC_TMR32B1->TCR = 1;				//タイマスタート
    var3= NVIC_GetPriority(TIMER_32_1_IRQn);


//    var=LPC_SYSCON->SYSAHBCLKDIV;
//	  var=SystemCoreClock;


    // Infinite loop.
    while (1) {
    	i++;
    }
    return 0;
}



//	RA
void TIMER16_0_IRQHandler (void)
{
	int a;
	a++;

    LPC_TMR16B0->IR =0x8;
}


//	DEC
void TIMER16_1_IRQHandler (void)
{
	int a;
	a++;

    LPC_TMR16B1->IR =0x8;
}


//	 恒星時時計、他
void TIMER32_0_IRQHandler (void)
{
static int timer=0;
	timer++;
	if (timer == 100){
		LPC_GPIO0->DATA ^= (1<<7);		// 点滅
		timer=0;
		sound_timer=100;				// Beepを鳴らす
	}
	LPC_TMR32B0->IR =0x8;
}


//	標準時、Beep
void TIMER32_1_IRQHandler (void)
{
static int time_cnt=0;

	if (sound_timer){
		LPC_GPIO0->DATA ^= (1<<8);		// Beep
		sound_timer--;
	}

	time_cnt++;
	if (time_cnt == 2000){
		timer_clock++;		// 経過時間更新
		time_cnt=0;
	}
    LPC_TMR32B1->IR =0x8;
}


